# Manual Sale

This function is used to request authorization and a sale in an offline scenario, which means that Shift4 will not seek processor approval. An authorization code should be included in this request if the amount being submitted in the request is greater than the authorization amount currently on file.
For Restaurant industry, review [Restaurant Authorization and Settlement Flow](/guides/core-concepts/restaurant-authorization-and-settlement-flow)
**Integration Methods:**
- Host Direct
- Locally Installed UTG
- Commerce Engine For On Premise
- Commerce Engine For Cloud

See the [Integration Methods](/guides/quickstart#integration-methods) and [URLs Section](/guides/quickstart#urls) sections of the Development Quick Start guide for details regarding each processing option.
See the [JSON Body Schemas](/guides/quickstart#json-body-schemas) for more details on the various JSON body formats.

Endpoint: POST /transactions/manualsale
Version: 1.7.65
Security: AccessToken

## Header parameters:

  - `InterfaceVersion` (string, required)
    Refers to the version of the program or application that is sending requests to Shift4. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ < > , ? “ ” ‘ ’ { } [ ] \ + =

  - `InterfaceName` (string, required)
    Refers to the name of the program or application that is sending requests to Shift4. This should be the name of the program that you purchased or created. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ ` < > , ? “ ” ‘ ’ { } [ ] \ + =

  - `CompanyName` (string, required)
    Refers to the vendor or partner that designed and certified the interface. The information you use in this field should match what Shift4 has on file or what was agreed upon in your Integration Plan. The following special characters are not allowed&colon;  $ % &colon; ^ - ~ ` < > , ? “ ” ‘ ’ { } [ ] \ + =

  - `AccessToken` (string, required)
    A security credential used to authenticate API requests and all [i4Go®](https://s4-myportal.s3.amazonaws.com/downloads/documentation/i4go/i4go%20technical%20reference%20guide.pdf) authorizeClient/preauthorizeClient requests. An Access Token is the alias for the merchant account and interface being used. The Access Token is required in all requests except an [Access Token Exchange](/apis/payments-platform-rest/openapi/credentials/accesstokenexchange) request, which generates an Access Token using an `authToken` and `clientGuid`.

## Request fields (application/json):

  - `dateTime` (string, required)
    The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
    Example: 2024-05-21T09:18:23.283-07:00

  - `amount` (object, required)
    Object containing information regarding the amount being requested. The `total` field within the object is required and specifies the amount being requested. All other fields are for informational purposes and must also be included in the `total` field. For example, a purchase of $100 with a $20 tip and $8 tax would be `128.00` in the `total` field, `20.00` in the `tip` field and `8.00` in the `tax` field.
Note: For merchants that are configured to allow multiple currencies, the amount  fields can specify up to three decimal places. However, the number of decimal  places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.

  - `amount.total` (number, required)
    The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
    Example: 160

  - `amount.tax` (number, required)
    The amount of sales tax charged for a transaction. The tax amount is used by businesses to track tax expenses for accounting purposes. Identifying the tax amount also helps consumers understand the total amount that they were billed.  This field is part of Level 2 card data.
    Example: 15

  - `amount.taxIndicator` (string)
    | Value | Description |
|  --- | --- |
| Y | Tax is included |
| N | Tax is not included |
    Enum: "Y", "N"

  - `amount.cashback` (number)
    Specifies the cashback amount in a transaction. When using a UTG-controlled PIN pad with the ALLOWCASHBACK API Option, this field will return the cashback amount requested by the consumer. The interface can also send the desired cashback amount in a request by adding it to the `amount.total` and including it in the `amount.cashback` field. This will bypass prompting the consumer for a cashback amount.
    Example: 20

  - `amount.iiasAmounts` (array)
    **Conditional: Send in the request if processing for a health care merchant.**
For Vision related charges you must send only `iiasAmounts.type = 4V` and the corresponding `iiasAmounts.amount` value.
For all other charges, the first entry in the array should have an amount representing the total of all healthcare costs, and `iiasAmounts.type = 4S`.  Any subsequent entries should contain the subtotal for each of the other expense types involved in this transaction.
    Example: [{"type":"4S","amount":75},{"type":"4W","amount":25}]

  - `amount.iiasAmounts.amount` (number)
    The subtotal for this type of healthcare expenses.
    Example: 34

  - `amount.iiasAmounts.type` (string)
    This code classifies eligible healthcare expenses.
| Value | Description |
|  --- | --- |
| 4O | Cash Disbursement (Discover Only) – Amount of Cash Back Being Requested |
| 4S | Healthcare (Visa/MC Only) – Qualified Medical Expenses or Over-the-Counter |
| 4T | Transit (Visa Only) – Transit Fare Media (e.g., Commuter and Parking Passes, Mass Transit Vouchers, and Tickets) |
| 4U | RX (Visa/MC Only) |
| 4V | Vision (Visa Only) |
| 4W | Clinical (Visa Only) |
| 4X | Dental (Visa Only) |
    Enum: "4O", "4S", "4T", "4U", "4V", "4W", "4X"

  - `amount.tip` (number)
    **Conditional: Send in the request if a tip is included.**
The tip amount of the transaction.
    Example: 20

  - `amount.checkTotal` (number)
    Optional field specifying the total amount of the entire bill/invoice that this transaction is part of. It can be larger than `amount.total` in scenarios where the check is being split or if a portion of the check was already paid in cash or another form of payment.
    Example: 200

  - `clerk` (object, required)

  - `clerk.numericId` (integer, required)
    A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    Example: 1576

  - `transaction` (object, required)

  - `transaction.invoice` (string, required)
    10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.
**Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.**
**For processing outside of the US and Canada alpha characters are allowed.**
    Example: 0510093358

  - `transaction.authorizationCode` (string, required)
    The authorization code provided by the consumer’s issuing bank. It is provided in a response if an online authorization or sale request is approved. Following a referral response, it is also specified in [Manual Sale](/apis/payments-platform-rest/openapi/transactions/manualsale) requests.
    Example: 198399

  - `transaction.manualTranId` (string)
    This is typically used in a Referral. If a ManualTranID is returned by the issuer with the Auth code, it should be sent to the processor in the ManualTranid field.
    Example: 123456789012345

  - `transaction.notes` (string)
    A free-form notes field that supports the use of HTML tags.  This can be used for reference in [Lighthouse Transaction Manager](https://ltm.shift4test.com/) and is not sent to the authorization host. Escaped quotation marks should not be sent in the Notes field.
    Example: Transaction notes are added here

  - `transaction.businessDate` (string)
    Desired business date of a transaction. Include when overriding the existing business date of a transaction. The overriding date may be earlier or later than the existing date. (yyyy-mm-dd)
    Example: 2021-04-15

  - `transaction.amex` (object)

  - `transaction.amex.propertyCode` (string)
    The code that contains a Merchant-assigned store or location number (or name) that uniquely identifies where the transaction took place.
    Example: 21546782948

  - `transaction.auto` (object)
    **Conditional: Utilize this object for Auto Rental transactions**

  - `transaction.auto.distanceDriven` (integer)
    The amount of distance the cardholder drove the vehicle.
    Example: 167

  - `transaction.auto.distanceUnit` (string)
    The unit of measure that corresponds to the `distanceDriven` field.
| Value | Description |
|  --- | --- |
| M | Miles |
| K | Kilometers |
    Enum: "M", "K"

  - `transaction.auto.lateAdjustment` (number)
    A dollar amount for late adjustment fees for an auto rental, including refueling charges, a surcharge, or charges for damage incurred during use.
    Example: 35

  - `transaction.auto.noShowIndicator` (string)
    Indicates whether or not the cardholder picked up a reserved rental car.
| Value | Description |
|  --- | --- |
| Y | customer did not pick up the rental car |
| N | customer did pick up the rental car |
    Enum: "Y", "N"

  - `transaction.auto.additionalCharges` (object)
    The codes used to provide a reason for additional charges in an auto rental sale. Multiple codes can be specified for the same transaction.

  - `transaction.auto.additionalCharges.gasoline` (string)
    Enum: "Y", "N"

  - `transaction.auto.additionalCharges.lateReturn` (string)
    Enum: "Y", "N"

  - `transaction.auto.additionalCharges.mileage` (string)
    Enum: "Y", "N"

  - `transaction.auto.additionalCharges.oneWayServiceFee` (string)
    Enum: "Y", "N"

  - `transaction.auto.additionalCharges.violationFee` (string)
    Enum: "Y", "N"

  - `transaction.auto.driver` (object)

  - `transaction.auto.driver.license` (string)
    The cardholder's driver's license number.
    Example: 1889624485

  - `transaction.auto.driver.name` (string)
    In a sale/authorization request for an auto rental, the customer’s name exactly as it appears on their driver’s license.
    Example: John Smith

  - `transaction.auto.driver.taxNumber` (string)
    This field contains the driver’s Tax Identification Number.
    Example: 192012838

  - `transaction.auto.rental` (object)
    Information relating to where the rental card was picked up.

  - `transaction.auto.rental.agreement` (string)
    Contract number for an auto rental agreement.
    Example: 123203592

  - `transaction.auto.rental.city` (string)
    City where rental car was picked up.
    Example: Las Vegas

  - `transaction.auto.rental.countryCode` (string)
    Country where rental card was picked up.
    Example: 840

  - `transaction.auto.rental.postalCode` (string)
    Postal Code where rental car was picked up in U.S. postal abbreviation format.
    Example: 83145

  - `transaction.auto.rental.region` (string)
    Region (State) where rental car was picked up in U.S. postal abbreviation format.
    Example: NV

  - `transaction.auto.return` (object)
    Information relating to where the rental car was returned

  - `transaction.auto.return.city` (string)
    City where rental car was returned.
    Example: Las Vegas

  - `transaction.auto.return.countryCode` (string)
    Country where rental card was returned.
    Example: 840

  - `transaction.auto.return.postalCode` (string)
    Postal Code where rental car was returned in U.S. postal abbreviation format.
    Example: 17721

  - `transaction.auto.return.region` (string)
    Region (State) where rental car was returned in U.S. postal abbreviation format.
    Example: NV

  - `transaction.airline` (object)
    **Conditional: Utilize this object for Airline transactions in Authorization/Sale requests when possible. If unable to provide this data at Authorization, this object must be sent in subsequent Capture requests for the transaction.**

  - `transaction.airline.carrierCode` (string, required)
    The code of the airline carrier issuing the ticket.
    Example: 5472

  - `transaction.airline.carrierName` (string, required)
    The name of the airline carrier issuing the ticket.
    Example: American Airlines

  - `transaction.airline.conjunctionTicketIndicator` (string, required)
    Indicates whether the itinerary contains more than four segments of travel.
| Value | Description |
|  --- | --- |
| Y | Yes |
| N | No |
    Enum: "Y", "N"

  - `transaction.airline.documentType` (string, required)
    This field contains the airline Document Type code, which indicates the purpose of this transaction. This information may appear on the descriptive bill on the Cardmember's statement, or be used to resolve billing inquiries and disputes. The codes entered in the Transaction Type and Document Type fields are used together to describe the purpose of this transaction.
| Value | Description |
|  --- | --- |
| 01 | Passenger Ticket |
| 02 | Additional Collection |
| 03 | Excess Baggage |
| 04 | Misc. Charge Order (MCO) / Prepaid Ticket Auth |
| 05 | Special Service Ticket |
| 06 | Supported Refund |
| 07 | Unsupported Refund |
| 08 | Lost Ticket Application |
| 09 | Tour Order Voucher |
| 10 | Ticket by Mail |
| 11 | Undercharge Adjustment |
| 12 | Group Ticket |
| 13 | Exchange Adjustment |
| 14 | SPD/Air Freight |
| 15 | In-flight Adjustment |
| 16 | Agency Passenger Ticket |
| 17 | Agency Tour Order/Voucher |
| 18 | Agency Misc. Charge Order (MCO) |
| 19 | Agency Exchange Order |
| 20 | Agency Group Ticket |
| 21 | Debit Adjustment Duplicate Refund/Use |
| 22 | In-flight Merchandise Ordered |
| 23 | Catalogue Merchandise Ordered |
| 24 | In-flight Phone Charges |
| 25 | Frequent Flyer Fee/Purchase |
| 26 | Kennel Charge |
| 27 | Animal Transportation Charge |
| 28 | Firearms Case |
| 29 | Upgrade Charge |
| 30 | Credit Unused Transportation |
| 31 | Credit Class of Service Adjustment |
| 32 | Credit Denied Boarding |
| 33 | Credit Misc. Refund |
| 34 | Credit Lost Ticket Refund |
| 35 | Credit Exchange Refund |
| 36 | Credit Overcharge Adjustment |
| 37 | Credit Multiple Unused Tickets |
| 38 | Exchange Order |
| 39 | Self-Service Ticket(s) |
| 41 | In-flight Duty Free Purchase |
| 42 | Senior Citizen Discount Booklets |
| 43 | Club Membership Fee |
| 44 | Coupon Book |
| 45 | In-flight Charges |
| 46 | Tour Deposit |
| 47 | Frequent Flyer Overnight Delivery Charge |
| 48 | Frequent Flyer Fulfillment |
| 49 | Small Package Delivery |
| 50 | Vendor Sale |
| 51 | Miscellaneous Tax(es) Fee(s) |
| 52 | Travel Agency Fee |
| 60 | Vendor Refund Credit |
| 64 | Duty Free Sale |
| 65 | Preferred Seat Upgrade |
| 66 | Cabin Upgrade |
| 67 | Lounge/Club Access or Day Pass |
| 68 | Agent Assisted Reservation. Ticketing Fee |
| 69 | Ticket Change or Cancel Fee |
| 70 | Trip Insurance |
| 71 | Unaccompanied Minor |
| 72 | Standby Fee |
| 73 | Curbside Baggage |
| 74 | Inflight Medical Equipment |
| 75 | Ticket or Pass Print Fee |
| 76 | Checked Sporting/Special Equipment |
| 77 | Dry Ice Fee |
| 78 | Mail/Postage Fee |
| 79 | Club Membership Fee - Temporary/Trial |
| 80 | Frequent Flyer Activation/Reinstatement |
| 81 | Gift Certificate |
| 82 | Onboard/Inflight Prepaid Voucher |
| 83 | Optional Services Fee |
| 84 | Advanced Purchase - Excess Baggage |
| 85 | Advanced Purchase - Preferred Seat Upgrade |
| 86 | Advanced Purchase - Cabin Upgrade |
| 87 | Advanced Purchase - Optional Services |
| 88 | WiFi |
| 89 | Packages |
| 90 | Inflight Entertainment/Internet Access |
| 91 | Overweight Bag Fee |
| 92 | Sleep Sets |
| 93 | Special Purchase Fee |
    Enum: "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "60", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93"

  - `transaction.airline.electronicTicketIndicator` (string, required)
    Indicates if an electronic ticket was issued.
| Value | Description |
|  --- | --- |
| Y | Yes |
| N | No |
    Enum: "Y", "N"

  - `transaction.airline.internetIndicator` (string, required)
    Indicates if this is an internet transaction.
| Value | Description |
|  --- | --- |
| Y | Yes |
| N | No |
    Enum: "Y", "N"

  - `transaction.airline.issueDate` (string, required)
    The date the ticket was issued to the customer. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
    Example: 2021-04-12T15:39:01.594-07:00

  - `transaction.airline.numberOfCities` (number, required)
    The number of airports or cities for each leg on the ticket (including origination and destination cities).
    Example: 5

  - `transaction.airline.numberOfCarriers` (number, required)
    This field contains the number of airline carriers.
    Example: 5

  - `transaction.airline.numberOfPassengers` (number, required)
    The number of passengers in the transaction.
    Example: 5

  - `transaction.airline.passengerArrivalDate` (string, required)
    Date that the ticket holder is scheduled to arrive at their destination at the time of issuance of the original ticket. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
    Example: 2021-04-14T15:39:01.594-07:00

  - `transaction.airline.passengerDepartureDate` (string, required)
    Date that the ticket holder is scheduled to depart at the time of issuance of the original ticket. The date may be a future one.  The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
    Example: 2021-04-13T15:39:01.594-07:00

  - `transaction.airline.passengerNameRecord` (string, required)
    A passenger name record (PNR) is a record in the database of a computer reservation system (CRS) that contains the itinerary for a passenger or a group of passengers travelling together
    Example: MXCTIF

  - `transaction.airline.restrictedTicketIndicator` (string, required)
    Indicates whether this ticket is non-refundable.
| Value | Description |
|  --- | --- |
| 0 | No restriction |
| 1 | Restricted (non-refundable) ticket |
    Enum: "0", "1"

  - `transaction.airline.ticketChangeIndicator` (string, required)
    Indicates why a ticket was changed.  This field should contain spaces or one of the below codes.
| Value | Description |
|  --- | --- |
| C | Change to existing ticket |
| N | New ticket |
    Enum: "C", "N"

  - `transaction.airline.ticketTranType` (string, required)
    This field contains the ticket transaction type code assigned to this transaction.
| Value | Description |
|  --- | --- |
| TKT | Ticket Purchase |
| REF | Refund |
| EXC | Exchange Ticket |
| MSC | Miscellaneous (non-Ticket Purchase- and non-Exchange Ticket-related transactions only) |
    Enum: "TKT", "REF", "EXC", "MSC"

  - `transaction.airline.typeIndicator` (string, required)
    Indicates if this ticket is a round trip, multi-city, or one-way ticket.
| Value | Description |
|  --- | --- |
| R | Round-Trip |
| O | One Way |
| M | Multi-City |
    Enum: "R", "O", "M"

  - `transaction.airline.tickets` (array, required)
    Array of ticket number and passenger name. Note: At least one instance of ticket number and passenger name info should be provided.
    Example: [{"ticketNumber":412345678901234,"passengerName":"Jane Doe","ticketFare":350},{"ticketNumber":412345678901236,"passengerName":"John Smith","ticketFare":250}]

  - `transaction.airline.tickets.passengerName` (string, required)
    Name of the passenger to whom the ticket was issued.  This field contains the Passenger Name in format:
`SURNAME FIRSTNAME MIDDLEINITIAL TITLE`
Example: "Doe Jane M Mrs"
    Example: Doe Jane M Mrs

  - `transaction.airline.tickets.ticketNumber` (string, required)
    The ticket number provided by the Carrier for the passenger.
    Example: 344567890234567

  - `transaction.airline.tickets.ticketFare` (number, required)
    Ticket fare is the total amount for each ticket, including service fee or any other fee for each ticket.
    Example: 350

  - `transaction.airline.flightLegs` (array, required)
    Array of flight trip leg info. Maximun 4 legs to a trip allowed. Note: At least one instance of flight trip leg info should be provided.
    Example: [{"tripLegInfo":"Trip Leg Info 1","couponNumber":1,"legDepartureDateTime":"2021-04-12T15:39:01.594-07:00","legArrivalDateTime":"2021-04-15T09:18:23.283-07:00","fare":300},{"tripLegInfo":"Trip Leg Info…

  - `transaction.airline.flightLegs.carrierCode` (string, required)
    Code indicating name of carrier (United Airlines, Jet Blue, etc.) for the leg.
    Example: DL

  - `transaction.airline.flightLegs.couponNumber` (number)
    Number of coupons in the ticket for the leg.
    Example: 1

  - `transaction.airline.flightLegs.destAirportCode` (string, required)
    Indicates destination city's airport code for the leg.
    Example: YXX

  - `transaction.airline.flightLegs.fare` (number, required)
    This field contains the total Fare for this trip segment. This is not the total amount billed to the customer.
    Example: 300

  - `transaction.airline.flightLegs.fareBasis` (string, required)
    This field contains primary and secondary discount codes that indicate the class of service and fare level associated with the ticket for the leg. Truncate at 24 bytes, if necessary.
    Example: YE3MAU

  - `transaction.airline.flightLegs.flightNumber` (string, required)
    Number of the airline flight to be taken on Leg of the trip.
    Example: 2490

  - `transaction.airline.flightLegs.legArrivalDateTime` (string, required)
    The date and time the flight is scheduled to arrive for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
    Example: 2021-04-15T09:18:23.283-07:00

  - `transaction.airline.flightLegs.legDepartureDateTime` (string, required)
    The date and time the flight is scheduled to depart for the leg. The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
    Example: 2021-04-12T15:39:01.594-07:00

  - `transaction.airline.flightLegs.originAirportCode` (string, required)
    Indicates origination city's airport code for the leg.
    Example: AUH

  - `transaction.airline.flightLegs.serviceClass` (string, required)
    Indicates service class for leg.
| Value | Description |
|  --- | --- |
| FC | First Class |
| BC | Business Class |
| EC | Economy/Coach Class |
    Example: FC

  - `transaction.airline.flightLegs.stopOverCode` (string, required)
    Indicates whether a stopover is allowed on this ticket for leg. The entry must be a D, O, or X.
| Value | Description |
|  --- | --- |
| O | Stopover allowed |
| X | Stopover not allowed |
| D | Destination point |
    Example: X

  - `transaction.airline.flightLegs.tripLegInfo` (string, required)
    Description of leg or stage of trip.
    Example: Trip Leg Info 1

  - `transaction.airline.ancillaryServices` (array)
    Array of ancillary service code and fees.
**Conditional: Send if any ancillary services were charged.**
    Example: [{"serviceCode":"BF","serviceFee":2},{"serviceCode":"BG","serviceFee":3}]

  - `transaction.airline.ancillaryServices.serviceCode` (string, required)
    This field describes the type of service that has been provided.
| Value | Description |
|  --- | --- |
| BF | Bundled Service |
| BG | Baggage Fee |
| CF | Change Fee |
| CG | Cargo |
| CO | Carbon Offset |
| FF | Frequent Flyer |
| GF | Gift Card |
| GT | Ground Transport |
| IE | In-Flight Entertainment |
| LG | Lounge |
| MD | Medical |
| ML | Meal/Beverage |
| OT | Other |
| PA | Passenger Assist Fee |
| PT | Pets |
| SA | Seat Fees |
| SB | Standby |
| SF | Service Fee |
| ST | Store |
| TS | Travel Service |
| UN | Unaccompanied Travel |
| UP | Upgrades |
| WI | Wi-Fi |
    Enum: "BF", "BG", "CF", "CG", "CO", "FF", "GF", "GT", "IE", "LG", "MD", "ML", "OT", "PA", "PT", "SA", "SB", "SF", "ST", "TS", "UN", "UP", "WI"

  - `transaction.airline.ancillaryServices.serviceFee` (number, required)
    This field contains the amount associated with the value provided in ancillary Service Code.
    Example: 2

  - `transaction.airline.travelAgencyCode` (string)
    Code identifying travel agency if the ticket was issued by a travel agency.
**Conditional: Send if a travel agency service was used.**
    Example: 05172343

  - `transaction.airline.travelAgencyName` (string)
    Name of travel agency if the ticket was issued by a travel agency.
**Conditional: Send if a travel agency service was used.**
    Example: State Travel

  - `transaction.airline.exchangeTicketNumber` (string)
    The original ticket number that was replaced by a new ticket number.
    Example: 507212345678768

  - `transaction.cardOnFile` (object)
    **Conditional: Send this object when the transaction being performed is using a card on file or when the request will result in storing a card on file.**
See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for more information.

  - `transaction.cardOnFile.type` (string)
    This field specifies the type of the card-on-file transaction.
Below is a table showing the valid values for use cases where the cardholder is entering their card data to store on file.
| Value | Initiator | Recurring | 3D Secure | Description |
|  --- | --- | --- | --- | --- |
| S01 | Cardholder | No | Yes | Used when the initial transaction/card verification request is not for a recurring payment. |
| S02 | Cardholder | Yes | Yes | Used when the initial transaction/card verification request is for a recurring payment. Requires sending `cardOnFile.recurringFrequency` and `cardOnFile.recurringExpiry` |

Below is a table showing the valid values for uses cases where you already have a card on file and are using that existing card to process a transaction.
| Value | Initiator | Recurring | 3D Secure | Description |
|  --- | --- | --- | --- | --- |
| U01 | Cardholder | No | Yes | Unscheduled transaction using the card on file initiated by the cardholder |
| U02 | Merchant | No | No | Unscheduled transaction using the card on file initiated by the merchant |
| U03 | Merchant | Yes | No | Merchant initiated recurring payment using the card on file |
| U04 | Merchant | No | No | Identifies a transaction as a Reauthorization COF transaction. |
| U05 | Merchant | No | No | Identifies a transaction as a Resubmission COF transaction. Only certain merchant categories are able to send a resubmission, and it can only be done if the original authorization attempt was declined due to insufficient funds. |
| U06 | Merchant | No | No | Identifies a transaction as an Estimated Authorization COF transaction. |
| U07 | Merchant | No | No | Identifies a transaction as a Delayed Charges COF transaction. For example, a hotel might charge a customer for room damages after the guest has already checked out. |
| U08 | Merchant | No | No | Identifies a transaction as an Incremental COF transaction. For example, a hotel which authorized a customer’s card for one night at check-in might increase the authorization amount to cover two nights when the customer decides to extend their stay. Shift4 automatically detects this scenario and sends the appropriate value to the processor. |
| U09 | Merchant | No | No | Identifies a transaction as a No Show COF transaction. For example, a hotel might charge a customer who does not show up for a booked stay. |

See the [Card On File Transactions](/guides/advanced-concepts/card-on-file-transactions) section for additional details.
    Enum: "S01", "S02", "U01", "U02", "U03", "U04", "U05", "U06", "U07", "U08", "U09"

  - `transaction.cardOnFile.recurringExpiry` (string)
    Date after which no further authorizations shall be performed. This field is limited to 8 characters, and the accepted format is YYYYMMDD.
**Conditional: This field is required if it's the first recurring transaction (`cardOnFile.type = S02`). This field is not needed if the transaction is not recurring or if the transaction is a subsequent recurring transaction.**
    Example: 20250401

  - `transaction.cardOnFile.recurringFrequency` (string)
    Indicates the minimum number of days between authorizations.
**Conditional: 'This field is required if it's the first recurring transaction (`cardOnFile.type = S02`). This field is not needed if the transaction is not recurring or if the transaction is a subsequent recurring transaction.**
    Example: 15

  - `transaction.cardOnFile.transactionId` (string)
    This field is returned in the initial COF response, and ties subsequent COF transactions to the original authorization.
For example, if a merchant runs a Sale on a card for the first time, they will receive a transactionId back in the response.  A month later, when the merchant wants to perform an additional Sale with the card on file, they would send a Sale request including the transactionId they received from the first sale.
**Conditional: Must be sent in subsequent COF requests if you are not processing with a Global Token Vault token. If using Global Token Vault tokens then this field is not required**
    Example: Z62537846172646

  - `transaction.cardOnFile.transactionLinkId` (string)
    A unique identifier assigned to each transaction to link related events throughout the transaction lifecycle, or to track the relationship between separate economically linked transactions. This field is supported for Mastercard brand only.
For example, if a merchant runs a Sale on a card for the first time, they will receive a transactionLinkId back in the response. A month later, when the merchant wants to perform an additional Sale with the card on file, they would send a Sale request including the transactionLinkId they received from the first sale.
**Conditional: Must be sent in subsequent COF requests if you are not processing with a Shift4 Token. If you are processing using a Shift4 Token, this field is not required.**
    Example: Z871868461726461879548

  - `transaction.hotel` (object)
    **Conditional: Utilize this object for Hotel transactions**

  - `transaction.hotel.arrivalDateTime` (string)
    Arrival date and time of a guest’s hotel stay ISO8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm). For hotel transactions that are a straight sale (such as advanced deposit, no-show charge, and late charges), the arrival date needs to be one day before the sale date.
    Example: 2021-04-12T15:39:01.594-07:00

  - `transaction.hotel.departureDateTime` (string)
    Departure date and time of a guest’s hotel stay ISO8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm). For hotel transactions that are a straight sale (such as advanced deposit, no-show charge, and late charges), the departure date needs to be the day of the sale.
    Example: 2021-04-15T09:18:23.283-07:00

  - `transaction.hotel.primaryChargeType` (integer)
    Guest’s transaction type at a hotel.
| Value | Description |
|  --- | --- |
| 1 | Lodging |
| 2 | Restaurant |
| 3 | Gift Shop |
    Enum: 1, 2, 3

  - `transaction.hotel.specialCode` (integer)
    This field is used to provide additional detail for lodging transactions. If a lodging charge does not match one of the listed descriptions, the default value of ‘1’ should be sent in the request. When a value of ‘4’ is sent, the `additionalCharges` field needs to be sent as well.
| Value | Description |
|  --- | --- |
| 1 | No Special Code |
| 2 | Assured Reservation/No Show |
| 3 | Advance Deposit |
| 4 | Delayed Charge |
| 5 | Express Check-Out Service |
| 6 | Assured Reservation/Normal |
    Enum: 1, 2, 3, 4, 5, 6

  - `transaction.hotel.additionalCharges` (object)
    Reason codes for additional charges in a lodging sale request at the time a consumer checks out.

  - `transaction.hotel.additionalCharges.giftShop` (string)
    Enum: "Y", "N"

  - `transaction.hotel.additionalCharges.laundry` (string)
    Enum: "Y", "N"

  - `transaction.hotel.additionalCharges.miniBar` (string)
    Enum: "Y", "N"

  - `transaction.hotel.additionalCharges.other` (string)
    Enum: "Y", "N"

  - `transaction.hotel.additionalCharges.restaurant` (string)
    Enum: "Y", "N"

  - `transaction.hotel.additionalCharges.telephone` (string)
    Enum: "Y", "N"

  - `transaction.hotel.roomRates` (array)
    Room rates broken down by rate and number of nights.
    Example: [{"nights":2,"rate":159.95},{"nights":3,"rate":125.38}]

  - `transaction.hotel.roomRates.nights` (integer)
    The number of nights being charged at this rate.
    Example: 2

  - `transaction.hotel.roomRates.rate` (number)
    The per night room rate.
    Example: 159.95

  - `transaction.purchaseCard` (object, required)

  - `transaction.purchaseCard.customerReference` (string, required)
    A unique value used to identify the consumer or transaction. If a merchant has a significant amount of revenue from purchasing card customers, the interface would use this field to collect the consumer’s purchase order or employee identification number. In lodging transactions, this may be unique transaction details, such as a reservation code or third-party booking source.  This field is part of Level 2 card data.
    Example: D019D09309F2

  - `transaction.purchaseCard.destinationPostalCode` (string, required)
    When items are shipped, the ZIP/postal code to which merchandise will be shipped; otherwise, the ZIP/postal code where the goods or services are rendered.  This field is part of Level 2 card data.
    Example: 94719

  - `transaction.purchaseCard.productDescriptors` (array, required)
    A text description of the items purchased or services sold. This can be a generic text description of what the merchant sells (such as “Groceries”) or specific transaction data (such as the name of the item sold). At least one product descriptor field is required in a sale or authorization request.
Note: The productDescriptors array is limited to 4 elements. Each element can contain a maximum of 40 characters.
    Example: ["Hamburger","Fries","Soda","Cookie"]

  - `transaction.vendorReference` (string)
    Optional field for information that can be searched in the merchant portal.
    Example: 12382-01

  - `device` (object)

  - `device.terminalId` (string)
    This field is optional and is for backwards compatibility with existing vendors that are used to processing via UTG controlled devices.
Since Commerce Engine is running directly on the payment device it does not require a `device.terminalId` to be specified.
    Example: 1742

  - `card` (object)

  - `card.present` (string)
    **Conditional: Send in the initial authorization/sale request**
Indicates whether a card was present (‘Y’) or not (‘N’) at the time a transaction took place. This should be set appropriately in the initial authorization/sale request.  In subsequent requests, this field should be left blank or should not be sent.
**Note:** Subsequent request here does not apply to the secondary request for card on file type transactions or reuse of the same card. An example of a subsequent request would be a capture after an authorization. You would not include `card.present` in the capture, which is the subsequent request. Another example is when performing an incremental authorization where you perform an authorization, followed by an incremental authorization then a capture. The second authorization (incremental) and the capture are the subsequent requests where you would not include `card.present`.
    Enum: "Y", "N"

  - `card.type` (string)
    An abbreviation used to specify the type of card that will be used when processing a transaction.  If an interface sends a value that is not listed here, that value will be ignored.
| Value | Description |
|  --- | --- |
| CC | When using a UTG-controlled device, this value will force a card to process as credit. |
| DB | When using a UTG-controlled device, this value will force a card to process as debit.  When using a non-UTG-controlled PIN pad, this value must be sent when processing a debit transaction. |
| GC | Gift Card |
| HF | HSA/FSA Card |
| PL | Private Label |
| YC | IT’S YOUR CARD |
    Enum: "CC", "DB", "GC", "HF", "PL", "YC"

  - `customer` (object)

  - `customer.addressLine1` (string)
    Cardholder’s street address exactly as it appears on their billing statement. This field is used in AVS.
    Example: 65 Easy St

  - `customer.firstName` (string)
    Specifies a consumer’s first name. This field is used in AVS. If the interface sends this field, the value specified by the interface will be returned in the response, unless the API Option [USECARDNAME](/guides/appendices/api-options#usecardname) is included in the request and a Commerce Engine or UTG-controlled PIN pad is in use. If the interface does not send the `customer` object, the consumer's name will be returned in the `customer` object if the name is present in the card's EMV or track data.
    Example: John

  - `customer.middleName` (string)
    Specifies a consumer’s middle name.
    Example: Andrew

  - `customer.lastName` (string)
    Specifies a consumer’s last name. This field is used in AVS. If the interface sends this field, the value specified by the interface will be returned in the response, unless the API Option [USECARDNAME](/guides/appendices/api-options#usecardname) is included in the request and a Commerce Engine or UTG-controlled PIN pad is in use. If the interface does not send the `customer` object, the consumer's name will be returned in the `customer` object if the name is present in the card's EMV or track data.
    Example: Smith

  - `customer.postalCode` (string)
    Cardholder’s ZIP/postal code from their billing statement. This field is used in AVS. Do not include special characters.
**Note: This field only allows alphanumeric characters (a-z, A-Z, 0-9). Special characters including - are not allowed. If you are sending in zip+4 you must not include the dash so 89134-1234 would be sent as 891341234**
    Example: 65144

  - `customer.emailAddress` (string)
    Customer email address.
    Example: john.smith@email.com

  - `customer.ipAddress` (string)
    Public source IP Address where the request originates, not the IP Address of the web server.
    Example: 63.57.84.101

  - `receiptColumns` (integer)
    Send this field if you want Shift4 to format the receipt text instead of returning individual fields. The value sent will correlate to the column width of the formatted receipt that we return. (This also allows the receipt text to wrap to fit the paper size of the printed receipt.) See the [Printing Receipts](/guides/core-concepts/printing-receipts) section of this document for more information on formatted receipts.
    Example: 40

  - `currencyCode` (string)
    Transaction currency code. See the [Currency Codes](/guides/appendices/currency-codes) section for details.
**Note: This is currently supported when processing for a merchant outside of the US and Canada. If processing for a US or Canadian merchant then this field will be ignored and the transaction will process in the merchant's configured currency.**
    Example: USD

  - `apiOptions` (array)
    API Options modify the request being made. See the [API Options](/guides/appendices/api-options) section for more information.
    Example: ["RETURNEXPDATE","ALLOWPARTIALAUTH"]

  - `statementSuffix` (string)
    Custom description that will be appended to the merchant name on the customer's statement. For most card brands, the merchant DBA name can be a maximum of 25 characters. Sending this value will cause the merchant name to be truncated to 9 characters. Shift4 will add an asterisk between the merchant name and the `statementSuffix` value.
For example, for a merchant named `Joe's Warehouse Emporium` that processes a transaction with `statementSuffix` value of `KDNYZUHQ1`, the merchant statement will show as `Joe's War*KDNYZUHQ1`.
**Note: The value that displays on customer statements from card issuers is beyond Shift4's control. We will submit the transaction data as described above, however issuers may modify or truncate that data as they see fit. To best accommodate different issuer limitations, we will truncate the merchant name to the minimum possible value (9 characters) in order to attempt to leave the most room for the statementSuffix to populate on issuer statements.**
    Example: KDNYZUHQ1

  - `ui` (object)

  - `ui.language` (string)
    ISO 639-1 2-letter language code specifying the UI display language for the transaction (e.g. "en", "fr", "de"). When provided, overrides the device's configured default language for the duration of the session. Value persists across transactions until a new value is passed. Send default to reset the device back to its default language.
    Example: en

  - `ui.mode` (string)
    Set the UI to light mode by sending `light` or dark mode by sending `dark`
    Enum: "light", "dark"

  - `ui.suppressFinalResult` (boolean)
    When `true`, the terminal suppresses the final transaction result screen.
    Example: true

  - `reportingData` (object)
    Used to send non-payment related data for reporting purposes.

  - `reportingData.customerInfo` (array)
    Array of customer information objects. The maximum number of customer information objects that can be sent is 10.
    Example: [{"firstName":"Jane","lastName":"Smith","dateOfBirth":"12011983","gender":"female","baggage":"checked","seats":"1A","boardingPriority":"1"},{"firstName":"John","lastName":"Smith","dateOfBirth":"012819…

  - `reportingData.customerInfo.firstName` (string)
    Customer's first name
    Example: John

  - `reportingData.customerInfo.lastName` (string)
    Customer's last name
    Example: Smith

  - `reportingData.customerInfo.dateOfBirth` (string)
    Customer's date of birth in MMDDYYYY format
    Example: 01281980

  - `reportingData.customerInfo.gender` (string)
    Customer's gender
    Example: male

  - `reportingData.customerInfo.baggage` (string)
    Description for the customer's baggage
    Example: carryon

  - `reportingData.customerInfo.seats` (string)
    Customer's assigned seat
    Example: 1A

  - `reportingData.customerInfo.boardingPriority` (string)
    Customer's boarding priority
    Example: 3

  - `reportingData.pspData` (object)
    Payment service provider (PSP) metadata for third-party processed transactions.

  - `reportingData.pspData.pspId` (string)
    PSP identifier / label
    Example: PSP Name XYZ

  - `reportingData.pspData.pspMid` (string)
    PSP merchant identifier (MID).
    Example: 123456

  - `reportingData.pspData.pspTid` (string)
    PSP terminal identifier (TID).
    Example: 12345678

  - `reportingData.pspData.pspTxnTraceNo` (string)
    PSP transaction trace number.
    Example: 000013

  - `reportingData.pspData.pspTxnDate` (string)
    PSP transaction date (YYYYMMDD).
    Example: 20260110

  - `reportingData.pspData.pspTxnTime` (string)
    PSP transaction time (hhmmss)
    Example: 235959

  - `reportingData.pspData.pspResponseCode` (string)
    PSP host response code.
    Example: 00

  - `reportingData.pspData.pspResponseText` (string)
    PSP host response description/text.
    Example: Payment Approved

  - `p2pe` (object, required)

  - `p2pe.data` (string, required)
    The full output of a P2PE keypad/magnetic swipe reader (MSR).
    Example: 027101801F2D1E00939B%*432100******1119^VS/DUAL TRACK^2212******?*;432100******1119=2212******?*CECE3FCE7781142BEC8D0E267AE89F5D3C7E235BF1A70E637951E8D93003E5A2586C336CA4A3B31F6639B04005BB12A716D8BC4D3…

  - `p2pe.format` (string, required)
    Classifies the type of payment device being used for P2PE.
| Value | Description |
|  --- | --- |
| 01 | IDTech Enhanced Encryption format (Keyboard Mode) |
| 02 | IDTech Enhanced Encryption format (USB HID Mode) |
    Enum: "01", "02"

  - `p2pe` (object, required)
    See [P2PE Format 05 TDES DUKPT](/guides/core-concepts/p2pe-format#tdes-dukpt---format-05) for more information.

  - `p2pe.format` (string, required)
    Classifies the type of payment device being used for P2PE.
| Value | Description |
|  --- | --- |
| 05 | [Shift4 TDES DUKPT format](/guides/core-concepts/p2pe-format#tdes-dukpt---format-05) |
    Enum: "05"

  - `p2pe.ksn` (string, required)
    The key serial number which was used to encrypt the P2PE data.
    Example: 6299495001100E200041

  - `emv` (object, required)
    **Conditional: Required when processing an EMV transaction without using a UTG.**

  - `emv.emptyCandidateList` (string)
    When EMV is attempted but fallback occurs due to an empty candidate list, this field should be sent as 'Y' and `emv.fallback` should also be sent as 'Y'.  If this field is not sent, a value of 'N' is assumed.
    Enum: "Y", "N"

  - `emv.tlvData` (string, required)
    This field will contain all EMV tags in standard TLV format including the P2PE encrypted tags (5A and 57).  The P2PE encrypted tags (5A and 57) will have the entire TLV string encrypted and the encrypted data will be in a TLV format using the same tag. For example, tag 5A would look like the following:
- Encrypted: 5A103737DA95D8062F647A0FF747CC496570
- Decrypted: 5A084761739001010010
    Example: 4F07A0000000041010500A4D61737465724361726457203CCEB572BE7DD0A38E62E6BD70E3DAACE9B46BD3BF65E188E7D8D68D2178DE1A5A10B1794BAC083B08F0A1444F189A5493255F201A546573742F43617264203039202020202020202020202020…

  - `p2pe` (object, required)
    See [P2PE Format 03 Ingenico On-Guard SDE](/guides/core-concepts/p2pe-format#ingenico-on-guard-sde---format-03) for more information.

  - `p2pe.data` (string, required)
    EMV TLV Data for tags 5A and 57 encrypted with AES 256 DUKPT. Contains the following information, separated by colons:
| Value | Description |
|  --- | --- |
| ksn | The key serial number (24 byte hex) |
| track indicator | `E` indicating EMV TLV Data |
| length | The length of the encrypted data |
| encrypted data | Encrypted TLV containing tags 57 and 5A |

Example: `FFFF495A0000000200000002:E:0032:E0AB94F7704E77AB37F81A7E236A1ABC1465C6DFCE43A506240D6E7D6DDA7EA9`
    Example: FFFF495A0000000200000002:E:0032:E0AB94F7704E77AB37F81A7E236A1ABC1465C6DFCE43A506240D6E7D6DDA7EA9

  - `p2pe.format` (string, required)
    Classifies the type of payment device being used for P2PE.
| Value | Description |
|  --- | --- |
| 03 | Ingenico Onguard SDE Format |
    Enum: "03"

## Response 200 fields (application/json):

  - `result` (array)

  - `result.dateTime` (string)
    The date and time in ISO 8601 format including the timezone offset (yyyy-mm-ddThh:mm:ss.nnn+hh:mm).
Must be sent as the local date/time of the merchant. For example, a request processed at a merchant in the Pacific time zone at 9:18am on April 15th 2021 would be sent as 2021-04-15T09:18:23.283-07:00
    Example: 2024-05-21T09:18:23.283-07:00

  - `result.amount` (object)
    Object containing information regarding the amount being requested. The `total` field within the object is required and specifies the amount being requested. All other fields are for informational purposes and must also be included in the `total` field. For example, a purchase of $100 with a $20 tip and $8 tax would be `128.00` in the `total` field, `20.00` in the `tip` field and `8.00` in the `tax` field.
Note: For merchants that are configured to allow multiple currencies, the amount  fields can specify up to three decimal places. However, the number of decimal  places can not exceed the number allowed for the specified currency. See the [Currency Codes](/guides/appendices/currency-codes) section for details.

  - `result.amount.total` (number, required)
    The amount being charged for a particular transaction. If other amount fields are sent, they must be included in the total amount. Amount cannot be zero.
    Example: 160

  - `result.amount.tax` (number, required)
    The amount of sales tax charged for a transaction. The tax amount is used by businesses to track tax expenses for accounting purposes. Identifying the tax amount also helps consumers understand the total amount that they were billed.  This field is part of Level 2 card data.
    Example: 15

  - `result.amount.taxIndicator` (string)
    | Value | Description |
|  --- | --- |
| Y | Tax is included |
| N | Tax is not included |
    Enum: "Y", "N"

  - `result.amount.cashback` (number)
    Specifies the cashback amount in a transaction. When using a UTG-controlled PIN pad with the ALLOWCASHBACK API Option, this field will return the cashback amount requested by the consumer. The interface can also send the desired cashback amount in a request by adding it to the `amount.total` and including it in the `amount.cashback` field. This will bypass prompting the consumer for a cashback amount.
    Example: 20

  - `result.amount.surcharge` (number)
    **Conditional: Send in the request if a surcharge was applied to the transaction.**
In a sale or authorization transaction, the `surcharge` field specifies a fee amount that a consumer is charged in addition to the transaction amount. The fee amount is also added into `amount.total`. For example, if the transaction request had `amount.total = 100` and the `surcharge.percentage` was 1.5% the transaction would include `amount.total = 101.50` and `amount.surcharge = 1.50`
    Example: 5

  - `result.amount.tip` (number)
    **Conditional: Send in the request if a tip is included.**
The tip amount of the transaction.
    Example: 20

  - `result.card` (object)

  - `result.card.entryMode` (string)
    **Conditional: The Card Entry Mode should be sent in an initial request; in subsequent requests, it should be left blank or not sent. When using a Universal Transaction Gateway® (UTG®)-controlled PIN pad, this field should be left blank or not sent in a request; the UTG will capture the card entry mode and return it in the response. When P2PE data is being sent from a non-UTG controlled device, this field is not needed**
The method used to capture a payment card in an authorization/sale request.
| Value | Description |
|  --- | --- |
| 1 | Track 1 Only or Dual Track (Track 1 & 2) |
| 2 | Track 2 Only |
| C | EMV Contactless via card or mobile wallet |
| E | EMV Chip |
| M | Manual Entry |
| Q | QR Code |
| R | Contactless MSD |
    Enum: "1", "2", "C", "E", "M", "Q", "R"

  - `result.card.expirationDate` (integer)
    **Conditional: Requires API Option "RETURNEXPDATE".**
Card expiration date in MMYY format. This value will only be populated if "RETURNEXPDATE" is included in the `apiOptions` array.
    Example: 1230

  - `result.card.levelResult` (string)
    Classifies the type of card used in an authorization/sale request. This field is returned in a response if the data is provided by the processor. See [Card Level Results]/guides/appendices/card-level-results) for a complete list of values.
    Example: 2C

  - `result.card.number` (string)
    The card number field will always be masked when returned in a response.
    Example: XXXXXXXXXXXX1119

  - `result.card.present` (string)
    **Conditional: Send in the initial authorization/sale request**
Indicates whether a card was present (‘Y’) or not (‘N’) at the time a transaction took place. This should be set appropriately in the initial authorization/sale request.  In subsequent requests, this field should be left blank or should not be sent.
**Note:** Subsequent request here does not apply to the secondary request for card on file type transactions or reuse of the same card. An example of a subsequent request would be a capture after an authorization. You would not include `card.present` in the capture, which is the subsequent request. Another example is when performing an incremental authorization where you perform an authorization, followed by an incremental authorization then a capture. The second authorization (incremental) and the capture are the subsequent requests where you would not include `card.present`.
    Enum: "Y", "N"

  - `result.card.type` (string)
    An abbreviation used to specify the type of card that was used when processing a transaction.
| Value | Description |
|  --- | --- |
| AX | American Express |
| AP | Alipay |
| BC | Backed Card |
| CI | Citgo |
| DB | Debit card |
| GC | Gift Card |
| JC | JCB |
| MC | Mastercard |
| NS | Discover/JCB/Novus |
| PL | Private Label |
| SC | Sears Canada |
| VS | Visa |
| WP | WeChat Pay |
| YC | IT’S YOUR CARD |
    Enum: "AX", "AP", "BC", "CI", "DB", "GC", "JC", "MC", "NS", "PL", "SC", "VS", "WP", "YC"

  - `result.card.balance` (object)

  - `result.card.balance.amount` (number)
    The balance remaining on the card.  Depending on which processor is being used, the balance may be returned for a gift card, debit card, EBT card, or other stored value card.
    Example: 24.33

  - `result.card.securityCode` (object)
    **Conditional: Returned if card.securityCode was sent in the request.**

  - `result.card.securityCode.result` (string)
    **Conditional: Returned if `card.securityCode.indicator` and `card.securityCode.value` are sent in the request.**
The result of a CSC check. This field will be used by Shift4 to determine the value sent in the `card.securityCode.valid` field (based on the merchant’s list of accepted verification results as configured with Shift4).
| Value | Description |
|  --- | --- |
| M | CSC matched. |
| N | CSC did not match. |
| P | CSC not processed. |
| S | CSC should have been present. |
| U | Issuer unable to process. |
| Y | CVC1 incorrect. |
| 1 | CSC Unavailable - processor / card type does not support this parameter. |
| 2 | An unrecognised result code was returned by the processor. |
| 3 | No result code was returned by the processor. |
    Enum: "M", "N", "P", "S", "U", "Y", "1", "2", "3"

  - `result.card.securityCode.valid` (string)
    **Conditional: Returned if `card.securityCode.indicator` and `card.securityCode.value` are sent in the request.**
A simplified CSC check result based on the value in the `card.securityCode.result` field and the merchant’s accepted verification results as configured with Shift4. The value returned will be ‘Y’ if CSC verification passed or ‘N’ if CSC verification did not pass.
    Example: Y

  - `result.card.token` (object)

  - `result.card.token.value` (string)
    This field is used to specify a card token. Whenever CHD is sent in a request, a card token will be returned in this field. Your interface should be designed to store this card token for future use. The latest card token received should be used in any subsequent request that references the same card data.
    Example: 8048471746471119

  - `result.card.debitType` (string)
    Specifies the type of debit card that was used when processing a transaction.
Only returned if `card.type` = `DB`
    Enum: "girocard", "eftpos", "Interac", "Visa Interlink", "Visa US Common Debit", "Maestro Int'l", "Maestro US Common Debit", "Amex US Common Debit", "Discover US Common Debit", "DNA Debit", "UnionPay"

  - `result.customer` (object)

  - `result.customer.firstName` (string)
    Specifies a consumer’s first name. This field is returned whenever the customer name is supplied in the request or if the track/EMV data contains the cardholder name.
    Example: John

  - `result.customer.lastName` (string)
    Specifies a consumer’s last name. This field is returned whenever the customer name is supplied in the request or if the track/EMV data contains the cardholder name.
    Example: Smith

  - `result.clerk` (object)

  - `result.clerk.numericId` (integer)
    A number used to identify the point-of-sale (POS) or property management system (PMS) clerk or user. The value cannot be 0. An interface must be able to dynamically populate this field (not use a hardcoded value), unless the interface will be used exclusively for e-commerce.
    Example: 1576

  - `result.merchant` (object)

  - `result.merchant.mid` (number)
    The merchant ID associated with the merchant account.
    Example: 15877

  - `result.merchant.name` (string)
    The merchant’s business name as configured with Shift4.
    Example: Merchant XYZ

  - `result.receipt` (array)
    Array of receipt key/value pairs that should be printed on the receipt.
    Example: [{"key":"ApplicationIdentifier","printName":"AID","printValue":"A0000000031010"},{"key":"TerminalVerificationResults","printName":"TVR","printValue":"8000"},{"key":"IssuerApplicationData","printName":…

  - `result.receipt.key` (string)
    The identifier the interface vendor can use to programmatically determine where to print a specific value.
    Example: ApplicationIdentifier

  - `result.receipt.printName` (string)
    The label that relates to the `printValue` field. When present in the response, this must be printed to the left of the `printValue`.
    Example: AID

  - `result.receipt.printValue` (string)
    The value that relates to the `printName` field. This must be printed to the right of the `printName`.
    Example: AID

  - `result.server` (object)

  - `result.server.name` (string)
    The name of the server that processed the request.
    Example: TM01CE

  - `result.signature` (object)

  - `result.signature.data` (string)
    The base64-encoded data sent when a signature is captured as a Portable Network Graphics (PNG) file.
    Example: iVBORw0KGgoAAAANSUhEUgAAA2kAAAEhCAYAAADlHOiOAAAABHNCSVQICAgIfAhkiAAAAAFzUkdCAK7OHOkAAAAEZ0FNQQAAsY8L/GEFAAAACXBIWXMAAA7EAAAOxAGVKw4bAACN0ElEQVR4Xu2dB5hU5dn3T97yJXnVqDTBWAABC2KhiFERUDQWLKioUWNAETQqRjT2…

  - `result.signature.format` (string)
    The data format the signature data will be in. "P" for PNG format.
    Enum: "P"

  - `result.transaction` (object)

  - `result.transaction.authorizationCode` (string)
    The authorization code provided by the consumer’s issuing bank. It is provided in a response if an online authorization or sale request is approved. Following a referral response, it is also specified in [Manual Sale](/apis/payments-platform-rest/openapi/transactions/manualsale) requests.
    Example: 198399

  - `result.transaction.authSource` (string)
    In a response, a code returned by the processor to indicate which host issued the response.
| Value | Description |
|  --- | --- |
| E | Engine (Online) |
| O | Offline |
| A | APM (Online) |
| F | Payment Platform (Online) |
    Enum: "E", "O", "A", "F"

  - `result.transaction.invoice` (string)
    10-digit invoice number assigned by the interface to identify a transaction. An invoice number serves as a unique key that identifies a transaction within a batch in Shift4's Gateway.
**Note: For US and Canadian processing: Although the invoice number is sent as a JSON string it is a numeric value. No alpha characters are allowed.**
**For processing outside of the US and Canada alpha characters are allowed.**
    Example: 0510093358

  - `result.transaction.responseCode` (string)
    Code indicating the Shift4 host response.
| Value | Description | Details |
|  --- | --- | --- |
| A | Approved | The transaction is approved. |
| C | Approved | The transaction is approved without requiring additional authorization because it is less than or equal to a ceiling amount. (The ceiling amount is the original authorization amount multiplied by the tolerance per the merchant’s settings with Shift4.) |
| D | Declined | The transaction is declined. Note: Shift4 automatically declines AVS/CSC failures if the [POSHANDLEAVSFAIL Api Option](/guides/appendices/api-options#poshandleavsfail) was not sent in the request. |
| e | [Error](/guides/appendices/error-codes) | There is an error condition. |
| f | [AVS or CSC failure](/guides/response-handling/understanding-avs-and-csc-verification) | An AVS or CSC failure has occurred (credit card only). Note: This value will only be returned if the [POSHANDLEAVSFAIL Api Option](/guides/appendices/api-options#poshandleavsfail) was sent in the request. |
| P | [Partial approval](/guides/advanced-concepts/partial-approval) | A partial approval has occurred.  Check `amount.total` for the approved amount. Note: If both the [ALLOWPARTIALAUTH](/guides/appendices/api-options#allowpartialauth) and [POSHANDLEAVSFAIL](/guides/appendices/api-options#poshandleavsfail) Api Options were sent in the request and the transaction is partially approved with an AVS or CSC failure, `P` is returned instead of `f`. The interface must check `avs.valid` and `card.securityCode.valid` to determine whether AVS or CSC verification failed and handle the failure itself. |
| R | Voice referral | The transaction requires a voice referral. |
| [blank] | Status is unknown | The approval status is unknown. |
| X | Expired card | There is an error condition due to the card being expired. |
| S | SCA Online PIN required | The contactless EMV transaction requires strong customer authentication to continue. The terminal must gather the online PIN if supported by the device form factor and CVM list then resubmit the transaction request. |
| I | SCA Interface switch required | The contactless EMV transaction requires strong customer authentication to continue. The terminal must look at the form factor indicator to determine if the transaction should be declined, switched to EMV contact or tapped again using CDCVM. |
| J | Soft decline after exemption request | Transaction was soft declined. Returned when requesting an exemption by sending `transaction.exemptionAction = 02` and the card issuer rejects the exemption. |
    Enum: "A", "C", "D", "e", "f", "P", "R", "X", "S", "I"

  - `result.transaction.saleFlag` (string)
    Specifies a transaction is a sale (‘S’) or credit (‘C’).  In an [Invoice Information](/apis/payments-platform-rest/openapi/transactions/getinvoice) request, an 'A' may be returned to differentiate an authorization from a sale.
    Enum: "A", "C", "S"

  - `result.transaction.amex` (object)

  - `result.transaction.amex.propertyCode` (string)
    The code that contains a Merchant-assigned store or location number (or name) that uniquely identifies where the transaction took place.
    Example: 21546782948

  - `result.transaction.avs` (object)

  - `result.transaction.avs.postalCodeVerified` (string)
    Identifies whether the ZIP/postal code was verified (‘Y’) or not (‘N’) in an AVS check with a processor.
    Enum: "Y", "N"

  - `result.transaction.avs.result` (string)
    Identifies the response code returned from an Address Verification System (AVS) check with a processor.
| Value | Description |
|  --- | --- |
| A | Street address matched, but ZIP/postal code did not match. |
| E | Error (AVS data is invalid or not allowed). |
| G | Card issuer does not participate in AVS. |
| N | No street address and no ZIP/postal code match. |
| R | Card issuer system is unavailable. |
| S | AVS service not supported. |
| U | Street address information unavailable. |
| W | Street address did not match, but ZIP/postal code matched. |
| X | Street address and 9-digit ZIP/postal code matched. |
| Y | Street address and 5-digit ZIP code matched. |
| Z | Only the ZIP/postal code matched. |
| 1 | Cardholder name and ZIP match |
| 2 | Cardholder name, address, and ZIP match |
| 3 | Cardholder name, address match |
| 4 | Cardholder name matches |
| 5 | Cardholder name incorrect, ZIP matches |
| 6 | Cardholder name incorrect; address and ZIP match |
| 7 | Cardholder name incorrect; address matches |
| 8 | Cardholder name, address, and ZIP do not match |
    Enum: "A", "E", "G", "N", "R", "S", "U", "W", "X", "Y", "Z", "1", "2", "3", "4", "5", "6", "7", "8"

  - `result.transaction.avs.streetVerified` (string)
    Identifies whether the street number was verified (‘Y’) or not (‘N’) in an AVS check with a processor.
    Enum: "Y", "N"

  - `result.transaction.avs.valid` (string)
    Simplified AVS result based on the merchant’s list of accepted responses as configured with Shift4: (‘Y’) if accepted or (‘N’) if not accepted.
    Enum: "Y", "N"

  - `result.universalToken` (object)

  - `result.universalToken.value` (string)
    An identifier for a card or payment account across all Shift4 merchants.
    Example: 97032276-5944-00000001-16985FD179D

  - `result.ui` (object)
    Information about the user interface presented on the payment device during the transaction.
**Note:** This object is only returned by Commerce Engine For On Premise and Commerce Engine For Cloud.

  - `result.ui.transactionResultLanguage` (string)
    Lowercase ISO 639-1 2-letter language code identifying the language used for the final transaction result screen displayed by Commerce Engine (e.g. "en", "fr", "de"). The value reflects the language actually used on that screen, regardless of how it was determined. A POS application that displays its own result screen can use this value to match the language shown to the consumer.
**Note:** This field is only returned by Commerce Engine For On Premise and Commerce Engine For Cloud.
    Example: fr

## Response 400 fields (application/json):

  - `result` (array)

  - `result.error` (object)

  - `result.error.code` (integer)
    Code indicating the type of error that occurred. Refer to the [Error Codes](/guides/appendices/error-codes) section of this document for more details.
**Note: This is currently only supported for European merchant processing.**
    Example: 64100

  - `result.error.severity` (string)
    Severity level of the error.
| Severity | Description |
|  --- | --- |
| Info | Action not required - Data input/formatting is incorrect |
| Error | Action may be required - Communication, timeout or network issue |
| Alert | Action required - System issue |
    Enum: "Info", "Error", "Alert"

  - `result.error.shortText` (string)
    Abbreviated error message that is always returned if an error condition exists
    Example: NOT IN CARDRANGE

  - `result.error.longText` (string)
    Extended error message that is returned if an error condition exists.
    Example: Card type not recognized

  - `result.error.primaryCode` (integer)
    Code indicating the type of error that occurred. Refer to the [Error Codes](/guides/appendices/error-codes) section of this document for more details.
    Example: 9842

  - `result.error.secondaryCode` (integer)
    This code supplements the code specified in the `error.primaryCode` field to provide additional information about the error that occurred.
    Example: 0

  - `result.lighthouse` (object)

  - `result.lighthouse.data` (string)
    Base64 encoded JSON formatted data that will be returned from Lighthouse to be passed back to SkyTab. This data will contain variable information.
    Example: eyJwYXltZW50SWQiOiI4NWM0MWNhNy01NzVjLTQzNGUtODIyZi0xYzZlOTE0ZDAzODYiLCJyZW1haW5pbmdBbW91bnQiOjB9

  - `result.server` (object)

  - `result.server.name` (string)
    The name of the server that processed the request.
    Example: TM01CE

## Response 504 fields (application/json):

  - `result` (array)

  - `result.error` (object)

  - `result.error.code` (integer)
    Code indicating the type of error that occurred. Refer to the [Error Codes](/guides/appendices/error-codes) section of this document for more details.
**Note: This is currently only supported for European merchant processing.**
    Example: 64100

  - `result.error.severity` (string)
    Severity level of the error.
| Severity | Description |
|  --- | --- |
| Info | Action not required - Data input/formatting is incorrect |
| Error | Action may be required - Communication, timeout or network issue |
| Alert | Action required - System issue |
    Enum: "Info", "Error", "Alert"

  - `result.error.shortText` (string)
    Abbreviated error message that is always returned if an error condition exists
    Example: NOT IN CARDRANGE

  - `result.error.longText` (string)
    Extended error message that is returned if an error condition exists.
    Example: Card type not recognized

  - `result.error.primaryCode` (integer)
    Code indicating the type of error that occurred. Refer to the [Error Codes](/guides/appendices/error-codes) section of this document for more details.
    Example: 9842

  - `result.error.secondaryCode` (integer)
    This code supplements the code specified in the `error.primaryCode` field to provide additional information about the error that occurred.
    Example: 0

  - `result.lighthouse` (object)

  - `result.lighthouse.data` (string)
    Base64 encoded JSON formatted data that will be returned from Lighthouse to be passed back to SkyTab. This data will contain variable information.
    Example: eyJwYXltZW50SWQiOiI4NWM0MWNhNy01NzVjLTQzNGUtODIyZi0xYzZlOTE0ZDAzODYiLCJyZW1haW5pbmdBbW91bnQiOjB9

  - `result.server` (object)

  - `result.server.name` (string)
    The name of the server that processed the request.
    Example: TM01CE

